"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ContextPlugin = require("@webiny/handler/plugins/ContextPlugin");

var _users = require("./crud/users.crud");

var _groups = _interopRequireDefault(require("./crud/groups.crud"));

var _apiKey = _interopRequireDefault(require("./crud/apiKey.crud"));

var _system = _interopRequireDefault(require("./crud/system.crud"));

var _default = () => {
  return new _ContextPlugin.ContextPlugin(async context => {
    if (!context.security) {
      // @ts-ignore
      context.security = {};
    } // @ts-ignore


    context.security.getTenant = () => {
      console.log(`[DEPRECATION] "context.security.getTenant()" is now deprecated! Use "context.tenancy.getCurrentTenant()" instead.`);
      return context.tenancy.getCurrentTenant();
    }; // @ts-ignore


    context.security.setTenant = tenant => {
      console.log(`[DEPRECATION] "context.security.setTenant()" is now deprecated! Use "context.tenancy.setCurrentTenant()" instead.`);
      context.tenancy.setCurrentTenant(tenant);
    };

    context.security.users = new _users.Users(context);
    context.security.groups = (0, _groups.default)(context);
    context.security.apiKeys = (0, _apiKey.default)(context);
    context.security.system = (0, _system.default)(context);
  });
};

exports.default = _default;
//# sourceMappingURL=context.js.map