"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _dbArgs = _interopRequireDefault(require("./dbArgs"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = context => {
  const {
    db,
    tenancy
  } = context;

  const keys = () => ({
    PK: `T#${tenancy.getCurrentTenant().id}#SYSTEM`,
    SK: "SECURITY"
  });

  return {
    async getVersion() {
      const rootTenant = await tenancy.getRootTenant();

      if (!rootTenant) {
        return null;
      }

      const [[system]] = await db.read(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
        query: keys()
      })); // Backwards compatibility check

      if (!system) {
        return "5.0.0-beta.4";
      }

      return system.version;
    },

    async setVersion(version) {
      const [[system]] = await db.read(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
        query: keys()
      }));

      if (system) {
        await db.update(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
          query: keys(),
          data: {
            version
          }
        }));
      } else {
        await db.create(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
          data: _objectSpread(_objectSpread({}, keys()), {}, {
            version
          })
        }));
      }
    }

  };
};

exports.default = _default;
//# sourceMappingURL=system.crud.js.map